/**
 * Created by lokeshagrawal on 10/05/17.
 */
import React, {Component} from 'react';

// to connect react with redux
import { connect } from 'react-redux';

// import action creator
import { selectBook } from '../actions/index';

// This is a function which we will use to make sure actions
// that is generated by action creator actually ends up flowing to
// all the different reducers.
import { bindActionCreators } from 'redux';

class BookList extends Component {
    renderList() {
        // expect someone to provide this.props.books to you.
        return this.props.books.map((book) => {
            return (
                <li onClick={() => this.props.selectBook(book)}
                    key={book.title}
                    className="list-group-item">
                        {book.title}
                </li>
            );
        });
    }

    // first create this.
    render() {
        return(
            <ul className="list-group col-sm-4">
                {this.renderList()}
            </ul>
        )
    }
}

// mapStateToProps fn is a Glue for react and redux,
// Whatever object is returned from mapStateToProps method, that object will be available to our component as this.props, for our case it is this.props.books

// notes:
// 1. whenever our application state changes (maybe from server or clicks from users).
// this container (mapStateToProps) will instantly be re-rendered with the new list of books.
//
// 2. whenever the application state changes the object in the state function will be assigned as a props to the component.
function mapStateToProps(state){
    // whatever object gets returned from here will show
    // up as this.props inside of BookList
    return {
        books: state.books
    };
}

// Anything returned from this function will end up as props on the BookList container.
// In reality whatever we passed here in the first argument (that is selectBook action creator)
// is going to be available as props to our container.
// we can use inside container as this.props.selectBook
function mapDispatchToProps(dispatch){

    // Whenever selectBook(action creator) is called, the result should be passed to all of our reducers. Thats what bindActionCreator does here, with the dispatch.
    // Its saying OK, I understand that you are going to call selectBook, I understand this is an actionCreator that you are going to call at some point of time,
    // whenever it gets called I wanna make sure that the result of it flows through this dispatch function
    // And this dispactch function is what takes all these actions from actioncreators and it basically receives them, kind of like a funnel and spits them back out
    // to all the different reducres in our application.

    // In summary bind action creators with dispatch says alright, I am going to take this stuff and I am going to take all these actions and make sure that they gets passed
    // on to all the different reducers inside our application.

    // Here key is selectbook and value is selectbook(action creator)
    return bindActionCreators({selectBook: selectBook}, dispatch);
}

// connect fn takes a function and a component and produces a container.
// and container is a component that is aware of the state that is contained by redux.

// Promote BookList from a component to a container.
// export default connect(mapStateToProps)(BookList);

// it needs to know about this new dispatch method, selectBook. Make is available as prop.
export default connect(mapStateToProps, mapDispatchToProps)(BookList);